#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <fcntl.h>

char page[12000];
char cookie[128];

int load_page(char *path) {
    int file_sz;
    size_t read_len;
    FILE *fp;

    snprintf(cookie, 128, "SSID=1337; path=/%s", path);
    if (strstr(path, "/") != 0) {
        printf("HTTP/1.1 550 Permission Denied\r\nContent-Type: text/html; charset=UTF-8\r\nServer: xinx/0.1 (Linux)\r\n\r\n<h1>550: Permission Denied<h1>");
        return -1;
    }
    fp = fopen(path, "r");
    if (fp == 0) {
        printf("HTTP/1.1 404 Not Found\r\nContent-Type: text/html; charset=UTF-8\r\nServer: xinx/0.1 (Linux)\r\n\r\n<h1>404: Page Not Found<h1>");
        return -1;
    }
    if ((fseek(fp, 0L, SEEK_END) < 0) || ((file_sz = ftell(fp)) < 0) || (fseek(fp, 0L, SEEK_SET) < 0)) {
        printf("HTTP/1.1 500 Internal Server Error\r\nContent-Type: text/html; charset=UTF-8\r\n\r\n<h1>500: Internal Server Error</h1>");
        return -1;
    }
    read_len = fread(page, 1, file_sz, fp);
    if (read_len == -1 || read_len >= sizeof(page)) {
        printf("HTTP/1.1 500 Internal Server Error\r\nContent-Type: text/html; charset=UTF-8\r\n\r\n<h1>500: Internal Server Error</h1>");
        return -1;
    }
    fclose(fp);
    page[read_len] = 0;
    if (strstr(path, ".html") != 0) {
        write(1, "HTTP/1.1 200 OK\r\nContent-Type: text/html; charset=UTF-8\r\nSet-Cookie: ", 69);
    } else {
        write(1, "HTTP/1.1 200 OK\r\nContent-Type: application/octet-stream; charset=UTF-8\r\nSet-Cookie: ", 69);
    }
    write(1, cookie, strlen(cookie));
    write(1, "\r\n\r\n", 4); 
    write(1, page, file_sz);
    return 0;
}

int main() {
    char host[128], path[128];
    memset(host, 0, 128);
    memset(path, 0, 128);

    scanf("GET %s HTTP/1.1\r\nHost: %s", path, host);

    if (strcmp(path, "/time") == 0) {
        system("date");
    }
    else if (strcmp(path, "/") == 0) {
        load_page("index.html");
    }
    else {
        /* skip '/' */
        load_page(path + 1);
    }

    return 0;
}
